#include "main.h"
#include "polyn.h"

void incKoef(float *koef, int count, float min, float max);
void printKoef(float *koef, int count);
void delej();

int main(int argc, char **arg) {
	if (argc > 2) {
		cout << arg[1] << endl;
	}

	try {
		delej();
	} catch (char *s) {
		cout << "Unhandled exception: " << s << endl;
	}
	
	return 0;
}

void delej() {
	int kmin = -5;
	int kmax = 5;
	int stmax = 4;
	int x = 0;
	int c = 0;

	float *koef = new float[stmax+1];
	Polyn *p;
	Roots *r;
	int korenu;

	cout << endl;
	cout << "     Program pro praci s polynomy" << endl;
	cout << "     vytvoreno jako pomucka k semestralni uloze 11 z X36TIN" << endl;
	cout << "     kveten 2007, Jan Pospisil, FEL, CVUT" << endl;
	cout << endl;
	cout << "  ---------------------------------------------------------------------" << endl;
	cout << endl;
	cout << "Spocitame pocet polynomu, ktere nemaji koreny." << endl;
	cout << "Pocitame polynomy stupne 2 a 4 s celociselnymi koeficienty z intervalu <" << kmin << "," << kmax << ">" << endl;
	cout << endl;
	for (int st = 2; st <= stmax; st++) {
		if (st == 3)
			continue;
		cout << "Pocitame polynomy " << st << ". stupne:" << endl;
		for (int i = 0; i < (st+1); i++)
			koef[i] = kmin;
		while (koef[st] <= kmax) {
			if ((st == 0) || (koef[st] != 0)) {
				cout << "Polynom: ";
				printKoef(koef, st+1);
				p = Polyn::make(st, koef);
				c++;
				r = p->getRoots();
				korenu = r->getCount();
				if (korenu > 0) {
					cout << " ma " << korenu << " koren(y/u).";
				} else {
					cout << " nema koren.";
					x++;
				}
				delete p;
				delete r;
				cout << endl;
			}
			incKoef(koef, st+1, kmin, kmax);
		}
		cout << endl;
	}
	cout << endl;
	cout << "Polynomu bez korene bylo " << x << " z celkoveho poctu " << c << " polynomu." << endl;
	cout << endl;
	x += 10;
	cout << "Pricteme k nim 10 (polynomy stupne -oo bez korene)" << endl;
	cout << "a dostaneme " << x << " polynomu maximalne 5. stupne bez korene.";
	cout << endl;
	x++;
	cout << "Pokud pricteme 1, dostaneme celkovy pocet komponent v zadanem grafu:" << endl;
	cout << "   " << x << endl;
	cout << endl;
}

void incKoef(float *koef, int count, float min, float max) {
	koef[0]++;
	for (int i = 0; i < (count-1); i++) {
		if (koef[i] > max) {
			koef[i] = min;
			koef[i+1]++;
		}
	}
}

void printKoef(float *koef, int count) {
	int i;
	for (i = 0; i < (count-1); i++) {
		cout << koef[i] << ", ";
	}
	cout << koef[i];
}
