#include "polyn_m.h"
#include <math.h>

float max(float a, float b);
float abs(float a);

PolynM::PolynM() {
	throw "Multi-polynom need specific data.";
}

PolynM::PolynM(int level, float *koef) {
	if (koef[level] == 0)
		throw "First koef. == 0.";
	PolynM::level = level;
	PolynM::koef = new float[level+1];
	for (int i = 0; i < (level+1); i++)
		PolynM::koef[i] = koef[i];
}

float PolynM::valueAt(float x) {
	if (x == 0)
		return koef[0];
	float result = koef[0];
	for (int i = 1; i < (level+1); i++)
		if (koef[i] != 0)
			result += koef[i]*pow(x,i);
	return result;
}

bool PolynM::isRoot(float root) {
	return (valueAt(root) == 0);
}

Roots *PolynM::getRoots() {
	Roots *result = new Roots(0);
	float A, B;
	float C = 0;
	float a, b;

	for (int i = 1; i < level; i++)
		C = max(C, abs(koef[i]));

	A = max(C, abs(koef[0]));
	B = max(C, abs(koef[level]));

	a = (abs(koef[0])/(B + abs(koef[0])));
	b = 1 + (A/abs(koef[level]));

	if (a > b)
		return result;

	float last = valueAt(-b);
	float next;
	for (float f = -b; f <= -a ; f += Polyn::STEP) {
		next = valueAt(f);
		if ((next == 0) || (next*last < 0)) {
			result->addRoot(f);
		}
		last = next;
	}

	last = valueAt(a);
	for (float f = a; f <= b ; f += Polyn::STEP) {
		next = valueAt(f);
		if ((next == 0) || (next*last < 0)) {
			result->addRoot(f);
		}
		last = next;
	}

	return result;
}

float max(float a, float b) {
	return (a < b) ? b : a;
}

float abs(float a) {
	return (a < 0) ? -a : a;
}
